var Selector = function (selector) {
    this.updateData(selector);
    this.initType();
};

Selector.prototype = {

    /**
     * Update current selector configuration
     * @param data
     */
    updateData: function (data) {
        var allowedKeys = ['id', 'type', 'selector', 'required', 'filters'];

        // update data
        for (var key in data) {
            if (allowedKeys.indexOf(key) !== -1 || typeof data[key] === 'function') {
                this[key] = data[key];
            }
        }

        // remove values that are not needed for this type of selector
        for (var key in this) {
            if (allowedKeys.indexOf(key) === -1 && typeof this[key] !== 'function') {
                delete this[key];
            }
        }
    },

    /**
     * CSS selector which will be used for element selection
     * @returns {string}
     */
    getItemCSSSelector: function () {
        return "*";
    },

    /**
     * override objects methods based on seletor type
     */
    initType: function () {

        if (window[this.type] === undefined) {
            throw "Selector type not defined " + this.type;
        }

        // overrides objects methods
        for (var i in window[this.type]) {
            this[i] = window[this.type][i];
        }
    },

    getDataElements: function () {
        var elements = $(this.selector);

        return elements;
    }
};