function Core() {
    this.configuration;
    this.navigation;
    this.formValues;
}

Core.prototype.initCasper = function () {
    casper.on('page.error', function (msg, trace) {
        var error = {
            msg: msg,
            file: trace[0].file,
            line: trace[0].line,
            func: trace[0]['function']
        };

        dataObj.errors.push(error);
    });

    casper.on('remote.message', function (msg) {
        var message = {
            url: casper.getGlobal('location').href,
            msg: msg
        };
        dataObj.messages.push(message);
    });

    casper.options.pageSettings = {
        loadImages: false,
        loadPlugins: false
    };

    casper.options.viewportSize = {width: 1600, height: 950};

    var clientScripts = [];
    var path = "../page/";
    var list = fs.list(path);

    for (var x = 0; x < list.length; x++) {
        var file = PATH_ROOT + '/page/' + list[x];
        if (fs.isFile(file)) {
            clientScripts.push(file);
        }
    }

    casper.options.clientScripts = clientScripts;
}

Core.prototype.loadConfiguration = function () {
    this.configuration = require(PATH_ROOT + "/plugins/" + casper.cli.options['load-plugin'] + "/config.json");

    if (typeof pluginHelper == "function" && typeof pluginHelper.afterStart == "function") {
        this.configuration = pluginHelper.afterStart(this.configuration);
    }
}

Core.prototype.loadFormValues = function () {
    var csv = new CSVFile();

    csv.load(PATH_ROOT + '/plugins/' + casper.cli.options['load-plugin'] + '/config-form.csv');
    this.formValues = csv.data;

    if (typeof pluginHelper == "function" && typeof pluginHelper.afterLoadFormConfiguration == "function") {
        this.formValues = pluginHelper.afterLoadFormConfiguration(this.formValues);
    }
}

Core.prototype.initLibraries = function () {
    this.navigation = new Navigation(this);
}

Core.prototype.run = function () {
    var crawler = new Crawler();
    crawler.init(this);
    crawler.run(this.configuration.startUrl);
}

module.exports = Core;
