function Crawler() {
    this.domainName;
    this.core;
    this.scraper;

    this.visitedUrls = [];
    this.pendingUrls = [];
    this.skippedUrls = [];

    this.requiredValues;
    this.skippedValues;
    this.countOfStepsLimit;
    this.actualCountOfSteps = 0;
    this.helper;
    this.navigateOnlyOne = 1;

    this.dataObj = {
        start: null,
        date: new Date(),
        dateFileName: false,
        requiredValues: null,
        skippedValues: null,
        links: [],
        errors: [],
        messages: [],
        skippedLinksCount: 0,
        logFile: '',
        linkCount: 1,
    };
}

Crawler.prototype.init = function (core) {
    this.core = core;
    this.helper = new Helper();
    this.scraper = new Scraper(core.configuration, this);
    this.domainName = this.helper.getDomainName(core.configuration.startUrl);
    this.requiredValues = this.domainName;
    this.skippedValues = core.configuration.skippedValues;
    this.countOfStepsLimit = core.configuration.countOfStepsLimit;
    this.dataObj.start = core.configuration.startUrl;
    this.dataObj.requiredValues = this.helper.prepareArr(this.requiredValues);
    this.dataObj.skippedValues = this.helper.prepareArr(this.skippedValues);
}

Crawler.prototype.run = function (url) {
        this.visitedUrls.push(url);
        var crawler = this;

        casper.then(function () {
            casper.open(url).then(function () {
                utils.dump(url);
                this.emit('create.screenshot');
                crawler.actualCountOfSteps++;

                crawler.navigate();

                this.emit('create.screenshot');

                var link = crawler.getLink(url);
                var baseUrl = this.getGlobal('location').origin;
                var localLinks = crawler.getLinks();

                crawler.dataObj.links.push(link);
                for (key in localLinks) {
                    crawler.prepareLink(localLinks[key], baseUrl);
                }

                if (crawler.pendingUrls.length > 0 && (!crawler.countOfStepsLimit || crawler.actualCountOfSteps < crawler.countOfStepsLimit) && crawler.core.configuration.crawlWeb) {
                    crawler.showInfo(crawler);
                    var nextUrl = crawler.pendingUrls.shift();
                    crawler.dataObj.linkCount++;
                    crawler.run(nextUrl);
                } else {
                    crawler.showInfo(crawler);
                }
            });
        });
};

Crawler.prototype.showInfo = function(crawler) {
    utils.dump('Pendigs: ' + crawler.pendingUrls.length + ' Visited: ' + crawler.visitedUrls.length + ' Skipped: ' + crawler.skippedUrls.length);
    utils.dump('Count of steps: ' + crawler.actualCountOfSteps);
}

Crawler.prototype.prepareLink = function (link, baseUrl) {
    var newUrl = this.helper.absoluteUri(baseUrl, link);

    var pattern = new RegExp(this.skippedValues);

    if (newUrl.indexOf(baseUrl) == -1) {
        this.skippedUrls.push(newUrl);
    }

    if (this.skippedValues.trim() != '' && pattern.test(newUrl) && this.skippedUrls.indexOf(newUrl) === -1) {
        this.skippedUrls.push(newUrl);
    }

    if (this.pendingUrls.indexOf(newUrl) === -1 &&
        this.visitedUrls.indexOf(newUrl) === -1 &&
        this.skippedUrls.indexOf(newUrl) === -1) {

        this.pendingUrls.push(newUrl);
    }
}

Crawler.prototype.getLink = function (url) {
    var status = casper.status().currentHTTPStatus;

    return {
        url: url,
        status: status
    };
}

Crawler.prototype.getLinks = function () {
    return casper.evaluate(function () {
        var links = [];
        __utils__.findAll('a[href]').forEach(function (e) {
            links.push(e.getAttribute('href'));
        });

        return links;
    });
}

Crawler.prototype.navigate = function () {
    var crawler = this;
    var numberRepetitions = this.core.formValues.length ? this.core.formValues.length : 1;
    casper.repeat(numberRepetitions, function () {
        if ((!crawler.core.configuration.crawlWeb && crawler.core.configuration.hasOwnProperty('recorder'))
            || (crawler.core.configuration.crawlWeb && crawler.navigateOnlyOne === 1 && crawler.core.configuration.hasOwnProperty('recorder'))) {
            casper.repeat(crawler.core.configuration.recorder.length, function () {
                crawler.core.navigation.navigate(crawler);

                if (!!crawler.countOfStepsLimit && crawler.actualCountOfSteps > crawler.countOfStepsLimit) {
                    return;
                }

                casper.emit('create.screenshot');
            });

            crawler.navigateOnlyOne = 0;
        }

        casper.then(function () {
            casper.emit('create.screenshot');
            result = crawler.scraper.getData();

            if (result) {
                results.push(result);
            }
            crawler.core.navigation.reset();
            crawler.core.navigation.nextFormValues();
        });

        if (!!crawler.countOfStepsLimit && crawler.actualCountOfSteps > crawler.countOfStepsLimit) {
            return;
        }
    });
}

module.exports = Crawler;