function CSVFile() {
    this.data;
    this.jsonFile = new JSONFile();
}

CSVFile.prototype.load = function (path, delimiter) {
    delimiter = typeof delimiter !== 'undefined' ? delimiter : ';';
    var file = fs.open(path, 'r');
    var line = file.readLine();

    var header = line.split(delimiter);

    this.data = [];

    while (line) {
        line = file.readLine();
        if (line) {
            columns = line.split(delimiter);
            var tmp = {};
            for (var i = 0; i < columns.length; i++) {
                tmp[header[i]] = columns[i];
            }
            this.data.push(tmp);
        }
    }

    file.close();

    return this.data;
}

CSVFile.prototype.write = function (path) {
    if (fs.exists(path)) {
        fs.remove(path);
    }

    var headerCreated = false;
    for (var key in this.data) {
        var row = this.data[key];
        var rowData = [];

        if (!headerCreated) {
            for (var objectName in row) {
                rowData.push(row[objectName]['name']);
            }

            headerCreated = true;
            fs.write(path, rowData.join(';') + '\n', 'a');
            rowData = [];
        }

        for (var objectName in row) {
            var object = row[objectName];
            if (this.jsonFile.isJSON(object['data'])) {
                rowData.push(this.decodeHtmlEntity(JSON.stringify(object['data'])));
            } else {
                rowData.push('"' + this.decodeHtmlEntity(object['data']) + '"');
            }
        }

        fs.write(path, rowData.join(';') + '\n', 'a');
    }

    if (!this.data.length) {
        rowData = [];

        fs.write(path, rowData.join(';') + '\n', 'a');
    }
}

CSVFile.prototype.decodeHtmlEntity = function (str) {
    var txt = document.createElement("textarea");
    txt.innerHTML = str;
    return txt.value;
};

module.exports = CSVFile;