function Country() {
    this.loadCountries();
}

Country.prototype = new FilterBase();

Country.prototype.loadCountries = function () {
    var file = new CSVFile();
    file.load(PATH_ROOT + '/assets/filters/country-cs.csv', ',');
    file.data.shift();
    this.countries = file.data;
    file.load(PATH_ROOT + '/assets/filters/country-en.csv', ',');
    file.data.shift();
    this.countries = this.countries.concat(file.data);
}

Country.prototype.cleanData = function (data) {
    if (!data) {
        return "Stát nenalezen";
    }

    for (var key in this.countries) {
        var regName = new RegExp("\s+" + this.countries[key].name.replace('"', '').replace('"', '') + "\s+", 'i');
        var regIso = new RegExp("\s+" + this.countries[key].iso + "\s+", 'i');
        var regName1 = new RegExp("^" + this.countries[key].name.replace('"', '').replace('"', '') + "\s+", 'i');
        var regIso1 = new RegExp("^" + this.countries[key].iso + "\s+", 'i');
        var regName2 = new RegExp("\s+" + this.countries[key].name.replace('"', '').replace('"', '') + "$", 'i');
        var regIso2 = new RegExp("\s+" + this.countries[key].iso + "$", 'i');
        var regName3 = new RegExp("^" + this.countries[key].name.replace('"', '').replace('"', '') + "$", 'i');
        var regIso3 = new RegExp("^" + this.countries[key].iso + "$", 'i');
        if (data.match(regName) || data.match(regIso) ||
            data.match(regName1) || data.match(regIso1) ||
            data.match(regName2) || data.match(regIso2) ||
            data.match(regName3) || data.match(regIso3)) {
            return this.countries[key].name.replace('"', '').replace('"', '') + '-' + this.countries[key].iso;
        }
    }

    return "Stát nenalezen";
}

module.exports = Country;