function Navigation(core) {
    this.core = core;
    this.step = 0;
    this.currentFormValues = 0;
}

Navigation.prototype.reset = function () {
    this.step = 0;
}

Navigation.prototype.navigate = function (crawler) {
    var navigationElement = new NavigationElement(this.core.configuration.recorder[this.step]);

    if (navigationElement.getMethodName() && typeof this[navigationElement.getMethodName()] == 'function') {
        eval('this.' + navigationElement.getMethodName())
        (navigationElement, this.core.configuration, this.core.formValues[this.currentFormValues], this.step);
    }

    var delay = this.getDelay(this.core.configuration.delay, this.step);

    if (delay) {
        utils.dump('Waiting for ' + delay + 's');
        casper.then(function () {
            casper.wait(delay * 1000);
        });
    }

    if (this.isStep(this.core.configuration.countStep, this.step)) {
        crawler.actualCountOfSteps++;
    }

    this.step++;
}

Navigation.prototype.getDelay = function (configurations, step) {
    for (var key in configurations) {
        if (configurations[key].id == (step + 1)) {
            return !parseInt(configurations[key].value) ? 0 : parseInt(configurations[key].value);
        }
    }

    return 0;
}

Navigation.prototype.isStep = function (configurations, step) {
    for (var key in configurations) {
        if (configurations[key].id == (step + 1)) {
            return configurations[key].value == 'true';
        }
    }

    return false;
}

Navigation.prototype.nextFormValues = function () {
    this.currentFormValues++;
}

Navigation.prototype.openUrl = function (navigationElement, configuration, data, step) {
    if (!configuration.crawlWeb) {
        casper.open(configuration.startUrl);
    }

    casper.emit('create.screenshot');
}

Navigation.prototype.change = function (navigationElement, configuration, data, step) {
    casper.waitForSelector(navigationElement.getSelector(),
        function () {
            utils.dump('Change ' + navigationElement.getSelector() + ' url ' + casper.getCurrentUrl());
            this.evaluate(function (selector, value) {
                jQuery(selector + ' option[value="' + value + '"]').each(function () {
                    jQuery(this).attr('selected', 'selected');
                });
            }, navigationElement.getSelector(), navigationElement.info.value);
        },
        function () {
            utils.dump(this.getCurrentUrl());
            console.log('Change error selector: ' + navigationElement.getSelector() + ' not found');
        });
}


Navigation.prototype.click = function (navigationElement, configuration, data, step) {
    casper.waitForSelector(navigationElement.getSelector(),
        function () {
            utils.dump('Click: ' + navigationElement.getSelector() + ' url: ' + casper.getCurrentUrl());
            this.click(navigationElement.getSelector());
        },
        function () {
            utils.dump(this.getCurrentUrl());
            console.log('Click error selector: ' + navigationElement.getSelector() + ' not found');
        }
    );
}

Navigation.prototype.submit = function (navigationElement, configuration, data, step) {
    casper.waitForSelector(navigationElement.getSelector(),
        function () {
            utils.dump('Submit: ' + navigationElement.getSelector() + ' url: ' + casper.getCurrentUrl());
            casper.thenEvaluate(function(selector) {
                document.querySelector(selector).submit();
            }, navigationElement.getSelector());
        },
        function () {
            console.log('Submit error selector: ' + navigationElement.getSelector() + ' not found');
        }
    );
}

Navigation.prototype.keypress = function (navigationElement, configuration, data, step) {
    casper.waitForSelector(navigationElement.getSelector(),
        function success() {
            utils.dump('Keypress: ' + navigationElement.getSelector() + ' text: ' + navigationElement.getInputText(configuration.formConfiguration, data, step) + ' url: ' + casper.getCurrentUrl());
            this.sendKeys(
                navigationElement.getSelector(),
                navigationElement.getInputText(configuration.formConfiguration, data, step)
            );
        },
        function fail() {
            console.log('Key press error selector: ' + navigationElement.getSelector() + ' not found');
        }
    );
}

module.exports = Navigation;
