var d = new Date();
var n = d.toLocaleString();
console.log(n);

var iconv = require('iconv-lite');
var Core = require("../scraper/core/core.js");
var Navigation = require("../scraper/navigation/navigation.js");
var NavigationElement = require("../scraper/navigation/navigationelement.js");
var CSVFile = require("../scraper/file/csv.js");
var JSONFile = require("../scraper/file/json.js");
var Filter = require("../scraper/filter/filter.js");
var FilterFactory = require("../scraper/filter/filterfactory.js");
var FilterBase = require("../scraper/filter/filterbase.js");
var Scraper = require("../scraper/scraper/scraper.js");
var Helper = require("../scraper/crawler/helper.js");
var Crawler = require("../scraper/crawler/crawler.js");

var casper = require('casper').create();
var utils = require('utils');
var fs = require('fs');
var core = new Core();
var results = [];

var currentFile = require('system').args[3];
var PATH_ROOT = fs.absolute(currentFile).split('/');
PATH_ROOT.pop();
PATH_ROOT = PATH_ROOT.join('/');
PATH_ROOT = PATH_ROOT + "/../";

var fileHelperPath = PATH_ROOT + '/plugins/' + casper.cli.options['load-plugin'] + '/helper.js';
if (fs.isFile(fileHelperPath)) {
    PluginHelper = require(fileHelperPath);

    if (typeof PluginHelper == "function") {
        var pluginHelper = new PluginHelper();
    }
}

core.initCasper();
core.loadConfiguration();
core.loadFormValues();
core.initLibraries();

casper.on('create.screenshot', function () {
    this.capture('../server/screenshot.png');
});

casper.start(core.configuration.startUrl);

casper.then(function () {
    core.run();
});

casper.on("resource.error", function (resourceError) {
    console.log('Unable to load resource (URL:' + resourceError.url + ')');
    console.log('Error code: ' + resourceError.errorCode + '. Description: ' + resourceError.errorString);
});

casper.on('exit', function () {
    if (typeof pluginHelper == "function" && typeof pluginHelper.beforeSave == "function") {
        results = pluginHelper.beforeSave(results);
    }

    var json = new JSONFile();
    json.data = results;
    json.write(PATH_ROOT + '/plugins/' + core.configuration._id + '/results.json');

    var csv = new CSVFile();
    csv.data = results;
    csv.write(PATH_ROOT + '/plugins/' + core.configuration._id + '/results.csv');
});

casper.run(function () {
    this.echo('Sraping ended.');

    var d = new Date();
    var n = d.toLocaleString();
    console.log(n);

    this.exit();
});
