function Scraper(configuration) {
    this.configuration = configuration;
    this.valid = true;
    this.filter = new Filter();
}

Scraper.prototype.getData = function() {
    var data = [];

    for (var key in this.configuration.selectors) {
        var selector = this.configuration.selectors[key];
        var result = this.evaluate(selector);

        if (selector.required && !result) {
            return null;
        }

        if (typeof pluginHelper == "function" && typeof pluginHelper.afterLoadFormConfiguration == "function") {
            result = pluginHelper.beforeFiltration(result, selector.id);
        }

        var scrapedData = {'name' : selector.id, 'data' : this.filter.cleanData(result, selector)};
        
        data.push(scrapedData);
    }
    return data;
}

Scraper.prototype.evaluate = function(selector) {
    return casper.evaluate(function(selector) {
        var factory = new SelectorFactory();
        var specificSelector = factory.getSelector(selector);

        var page = new Page();
        return page.getData(specificSelector);
    }, selector);
}

module.exports = Scraper;

